<!-- <div class="jarvis_wrap"> -->
<ng-container *ngIf="!chatModeFullPage">

    <div id="message_window" [ngClass]="messageBoXClass">
        <div class="chat_panel">
            <div class="panel2">
                <div class="powered_by">
                    <div *ngIf="!layoutService.report_id" class="chat_HX"><img src="assets/img/logo-lg.svg" /></div>
                    <div *ngIf="!layoutService.report_id" class="botProfile">
                        <div *ngIf="!activeConversation.totalParticipants" class="botname">Chatbot </div>
                        <div *ngIf="activeConversation.totalParticipants" class="botname">{{activeConversation.name}}
                        </div>
                        <div class="botStatus">
                            <div class="disconnected">Disconnected... <span class="blinking">reconnecting!</span></div>
                            <div class="offline">Offline! Reload to reconnect.</div>
                            <div class="online">Online</div>
                            <div *ngIf="activeConversation.totalParticipants" class="participant">
                                {{(activeConversation.totalParticipants ? '&nbsp;| ' + activeConversation.totalParticipants + ' members' : '' )}}
                            </div>
                        </div>
                    </div>

                    <div *ngIf="layoutService.report_id" class="botProfile">
                        <div *ngIf="!activeConversation.totalParticipants" class="botname"
                            [ngbTooltip]="layoutService.viewTitle">Comments on
                            {{layoutService.viewTitle.length > 15 ?  layoutService.viewTitle.substring(0,12) + "..." : layoutService.viewTitle}}
                        </div>

                    </div>

                    <div class="botaction">
                        <i *ngIf="!layoutService.report_id" (click)="resize()" [ngbTooltip]="getIconToolTip('expander')"
                            [className]="messageBoXClass == 'message_window_max' ? 'ion ion-md-contract' : 'ion ion-md-expand'"></i>
                        <i *ngIf="!layoutService.report_id" (click)="startNew()" class="ion ion-ios-refresh"
                            [ngbTooltip]="getIconToolTip('startNew')"></i>
                        <i (click)="closeMessageWin()" class="ion ion-ios-close" [ngbTooltip]="getIconToolTip('close')"
                            style="font-size:22px;"></i>
                        <!-- <i class="fa fa-user-plus" matTooltip="Add People" matTooltipPosition="right"></i> -->
                        <!-- <i (click)="closeMessageWin()" class="fa fa-user-plus" [ngbTooltip]="getIconToolTip('close')"></i> -->
                    </div>
                </div>
                <section>
                    <div id="message_list">
                        <div id="message_template">
                            <div class="message {{message.type}}">
                                <!-- {{#if message.isTyping}} -->
                                <div *ngIf="message.isTyping" class="typing-indicator">
                                    <span></span>
                                    <span></span>
                                    <span></span>
                                </div>
                                {{message.html}}

                                <!-- {{#if message.open_link}} -->
                                <a *ngIf="message.open_link" href="{{message.open_link}}" target="_blank"
                                    class="button_message">
                                    <ng-container *ngIf="message.link_title">
                                        {{message.link_title}}
                                    </ng-container>
                                    <ng-container *ngIf="!message.link_title">
                                        {{message.open_link}}
                                    </ng-container>
                                </a>
                                <!-- {{/if}} -->
                            </div>
                        </div>
                        <ng-container *ngFor="let item of Botkit.chatThread;let ind = index">
                            <!-- <div [className]="item.indexOf('userchat')>-1?'chatThreadOuter userchat':'chatThreadOuter'"> -->
                            <div
                                [className]="item.text.indexOf('userchat')>-1?'chatThreadOuter userchat':'chatThreadOuter'">
                                <div>
                                    <div class="chatThreadBox">
                                        <!-- <div [innerHTML]="item" class="chatThread" style="align-items: center;"></div> -->
                                        <div [innerHTML]="item.text" class="chatThread"></div>
                                        <ng-container
                                            *ngIf="item.text.indexOf('Hello, How can I help?') == -1  && item.text.indexOf('typing-indicator') == -1">
                                            <div class="chatAction">
                                                <i class="fa fa-ellipsis-v"
                                                    (mouseover)="Botkit.hoverActionItems($event,ind)"></i>
                                                <div class="tooltipPanel">
                                                    <ul class="tooltiptext">
                                                        <li (click)="this.Botkit.copyChat(item.text,ind)"
                                                            *ngIf="item.text.indexOf('allFilters') == -1 && item.text.indexOf('chart-scroll-box') == -1 ">
                                                            <i class="fas fa-copy"></i>Copy</li>
                                                        <li (click)="this.Botkit.copyChatSession(item.text,(ind))"
                                                            *ngIf="item.text.indexOf('allFilters') == -1 && item.text.indexOf('chart-scroll-box') == -1 ">
                                                            <i class="fas fa-comment-alt"></i>New Conversation</li>
                                                        <!-- <li
                                                            (click)="this.Botkit.deleteConversationMessage(item.text,ind)">
                                                            <i class="fa fa-trash"></i>Remove</li> -->

                                                        <li
                                                            (click)="Botkit.openDialog(deleteMessage, { windowClass: 'modal-fill-in modal-xlg modal-lg animate' },'deleteMessage',item.text,ind)">
                                                            <i class="fa fa-trash"></i>Remove</li>

                                                    </ul>
                                                </div>
                                            </div>
                                        </ng-container>
                                    </div>
                                    <div *ngIf="!item.message.isTyping" class="timestamp">
                                        {{item.message.timeFromNow }}
                                    </div>
                                </div>
                            </div>
                        </ng-container>
                    </div>
                    <!-- User suggestion box starts -->
                    <ng-container *ngIf="showUserSuggestion">
                        <div class="userSuggestion">
                            <ul class="userlist">
                                <ng-container *ngFor="let item of activeConversation.userNamesToRender;let ind = index">
                                    <li (click)="Botkit.selectUserSuggession(item,ind)">
                                        <div class="chat_PicBox"><span title="{{item}}"
                                                [className]="'chat_pic profilepic_Initia_'+activeConversation.firstInitial[item]">{{activeConversation.memberInitials[item]}}</span>
                                        </div>
                                        <label>{{item}}</label>
                                    </li>
                                </ng-container>
                            </ul>
                        </div>
                    </ng-container>
                    <!-- User suggestion box ends -->
                </section>
                <div id="message_replies"></div>
                <footer class="messageFooter">
                    <!-- <form onsubmit="Botkit.send(Botkit.input.value, event)"> -->
                    <form (ngSubmit)="this.Botkit.send(inputTextInput.value,$event)">
                        <div class="inputPanel">
                            <!-- <i class="ion ion-ios-attach icocolor"></i> -->
                            <input #inputTextInput type="text" autocomplete="off" id="messenger_input"
                            [placeholder]="!layoutService.report_id ? 'Ask for Data...' :'Add Comment...'"
                                (keydown)="Botkit.onKeyDownHandler($event)" (blur)="Botkit.resetSuggestion()" />
                            <!-- <i class="fa fa-smile icocolor2"></i> -->
                            <!-- <i (click)="chatSpeechRecognition()" class="ion ion-ios-mic micro-phone icocolor"></i> -->
                        </div>
                        <button [ngbTooltip]="'Send'" type="submit"><i class="fa fa-paper-plane fa-2x"></i></button>
                    </form>
                </footer>
            </div>
        </div>
    </div>
</ng-container>










<ng-container *ngIf="chatModeFullPage">

    <div id="message_window" [ngClass]="messageBoXClass">
        <div [ngClass]="listenerCss">
            <div class="circle-ripple">
                <span>{{speechText}}</span>
                <div>
                    <i *ngIf="isPausedRecognition" (click)="chatSpeechRecognition()"
                        class="fa fa-play-circle fa-lg"></i>
                    <i *ngIf="!isPausedRecognition" (click)="pauseVoiceCommand()" class="fa fa-pause-circle fa-lg"></i>
                    <i (click)="closeVoiceScreen()" class="fa fa-times-circle fa-lg"></i>
                </div>
            </div>
        </div>
        <div class="chat_panel">
            <ng-container>
                <div class="panel1">
                    <div class="panelheader">
                        <div class="title">Conversations</div>
                        <div class="tagline">View Saved Chats
                            <!-- <i class="fa fa-trash fa-sm"
                                                        (click)="Botkit.deleteAllConversation()" matTooltip="Delete All"
                                                        matTooltipPosition="right"></i> -->
                        </div>
                    </div>
                    <form>
                        <div class="inputPanel">
                            <!-- <i class="ion ion-ios-attach icocolor"></i> -->
                            <input id="txtfilterConversation" #filterConversation type="text" autocomplete="off"
                                placeholder="Search Conversations..." (input)="Botkit.filterConversations($event)" />
                            <i class="ion ion-ios-search icocolor"></i>
                        </div>
                    </form>
                    <ul>
                        <ng-container *ngFor="let item of Botkit.chatSessionList;let ind = index">
                            <li [className]="activeConversation._id == item._id ? 'active convItem' : 'convItem'">
                                <!-- <i class="ion ion-ios-chatboxes"></i>     -->
                                <div class="chatItem">
                                    <i class="fa fas fa-hashtag fa-sm"></i>
                                    <ng-container *ngIf="!item.editRow">
                                        <div class="textwrap" (click)="Botkit.selectCurrentSession(item,ind)"
                                            title="{{(item.name) ? item.name : 'New Conversation..'}}">
                                            {{(item.name) ? item.name : 'New Conversation..'}}</div>
                                    </ng-container>
                                    <ng-container *ngIf="item.editRow">
                                        <div class="textinput"><input id="txtConversationName" #txtConversationName
                                                type="text" [value]="item.name ? item.name : 'New Conversation..'"
                                                (blur)="Botkit.saveConversationName(txtConversationName.value,item,ind)">
                                        </div>
                                    </ng-container>
                                    <div class="convaction">
                                        <i (click)="Botkit.editConversation(item,ind)" class="fa fa-pencil-alt fa-sm"
                                            matTooltip="Edit" matTooltipPosition="above"></i>
                                        <i (click)="Botkit.shareConversation(item._id,ind)"
                                            class="fa fa-share-alt fa-sm" matTooltip="Share"
                                            matTooltipPosition="above"></i>
                                        <!-- <i (click)="Botkit.deleteConversation(item._id,ind)" class="fa fa-trash fa-sm"
                                            matTooltip="Delete" matTooltipPosition="above"></i> -->

                                        <i (click)="Botkit.openDialog(deleteConversation, { windowClass: 'modal-fill-in modal-xlg modal-lg animate' },'deleteConversation',item._id,ind)"
                                            class="fa fa-trash fa-sm" matTooltip="Delete"
                                            matTooltipPosition="above"></i>
                                           
                                    </div>
                                </div>
                                <div class="shareByTitle" *ngIf="item.sharedBy">Shared By : {{item.sharedBy.fullName}}
                                </div>
                            </li>
                        </ng-container>

                    </ul>
                    <div class="newchatbox">
                        <div class="newchatbtn" (click)="startNew()">
                            <i class="fa fa-plus"></i><span>New Chat</span>
                        </div>
                    </div>
                </div>
            </ng-container>
            <div class="panel2_full">
                <div class="powered_by">
                    <div class="chat_HX"><img src="assets/img/logo-lg.svg" /></div>
                    <div class="botProfile">
                        <div *ngIf="!activeConversation.totalParticipants" class="botname">Chatbot</div>
                        <div *ngIf="activeConversation.totalParticipants" class="botname">{{activeConversation.name}}
                        </div>
                        <div class="botStatus">
                            <div class="disconnected">Disconnected... <span class="blinking">reconnecting!</span></div>
                            <div class="offline">Offline! Reload to reconnect.</div>
                            <div class="online">Online</div>
                            <div *ngIf="activeConversation.totalParticipants" class="participant">
                                <span class="cursorHand" (click)="showAddedPeople = true">&nbsp;|
                                    {{activeConversation.totalParticipants + ' members'}}</span>
                            </div>
                        </div>
                    </div>
                    <div class="botaction" (click)="Botkit.addPeople()">
                        <i class="fa fa-user-plus" matTooltip="Add People" matTooltipPosition="right"></i>
                        <!-- <i (click)="closeMessageWin()" class="fa fa-user-plus" [ngbTooltip]="getIconToolTip('close')"></i> -->
                    </div>
                </div>
                <section>
                    <div id="message_list">
                        <div id="message_template">
                            <div class="message {{message.type}}">
                                <!-- {{#if message.isTyping}} -->
                                <div *ngIf="message.isTyping" class="typing-indicator">
                                    <span></span>
                                    <span></span>
                                    <span></span>
                                </div>
                                {{message.html}}

                                <!-- {{#if message.open_link}} -->
                                <a *ngIf="message.open_link" href="{{message.open_link}}" target="_blank"
                                    class="button_message">
                                    <ng-container *ngIf="message.link_title">
                                        {{message.link_title}}
                                    </ng-container>
                                    <ng-container *ngIf="!message.link_title">
                                        {{message.open_link}}
                                    </ng-container>
                                </a>
                                <!-- {{/if}} -->
                            </div>
                        </div>
                        <ng-container *ngFor="let item of Botkit.chatThread;let ind = index">
                            <!-- <div [className]="item.indexOf('userchat')>-1?'chatThreadOuter userchat':'chatThreadOuter'"> -->
                            <div
                                [className]="item.text.indexOf('userchat')>-1?'chatThreadOuter userchat':'chatThreadOuter'">
                                <div>
                                    <div class="chatThreadBox">
                                        <!-- <div [innerHTML]="item" class="chatThread" style="align-items: center;"></div> -->
                                        <div [innerHTML]="item.text" class="chatThread"></div>
                                        <ng-container
                                            *ngIf="item.text.indexOf('Hello, How can I help?') == -1  && item.text.indexOf('typing-indicator') == -1">
                                            <div class="chatAction">
                                                <i class="fa fa-ellipsis-v"
                                                    (mouseover)="Botkit.hoverActionItems($event,ind)"></i>
                                                <div class="tooltipPanel">
                                                    <ul class="tooltiptext">
                                                        <li (click)="this.Botkit.copyChat(item.text,ind)"
                                                            *ngIf="item.text.indexOf('allFilters') == -1 && item.text.indexOf('chart-scroll-box') == -1 ">
                                                            <i class="fas fa-copy"></i>Copy</li>
                                                        <li (click)="this.Botkit.copyChatSession(item.text,(ind))"
                                                            *ngIf="item.text.indexOf('allFilters') == -1 && item.text.indexOf('chart-scroll-box') == -1 ">
                                                            <i class="fas fa-comment-alt"></i>New Conversation</li>
                                                        <!-- <li
                                                            (click)="this.Botkit.deleteConversationMessage(item.text,ind)">
                                                            <i class="fa fa-trash"></i>Remove</li> -->

                                                        <li
                                                            (click)="Botkit.openDialog(deleteMessage, { windowClass: 'modal-fill-in modal-xlg modal-lg animate' },'deleteMessage',item.text,ind)">
                                                            <i class="fa fa-trash"></i>Remove</li>

                                                    </ul>
                                                </div>
                                            </div>
                                        </ng-container>
                                    </div>
                                    <div *ngIf="!item.message.isTyping" class="timestamp">
                                        {{item.message.timeFromNow }}
                                    </div>
                                </div>
                            </div>
                        </ng-container>
                    </div>
                    <!-- User suggestion box starts -->
                    <ng-container *ngIf="showUserSuggestion">
                        <div class="userSuggestion">
                            <ul class="userlist">
                                <ng-container *ngFor="let item of activeConversation.userNamesToRender;let ind = index">
                                    <li (click)="Botkit.selectUserSuggession(item,ind)">
                                        <div class="chat_PicBox"><span title="{{item}}"
                                                [className]="'chat_pic profilepic_Initia_'+activeConversation.firstInitial[item]">{{activeConversation.memberInitials[item]}}</span>
                                        </div>
                                        <label>{{item}}</label>
                                    </li>
                                </ng-container>
                            </ul>
                        </div>
                    </ng-container>
                    <!-- User suggestion box ends -->
                </section>
                <div id="message_replies"></div>
                <footer class="messageFooter">
                    <form (ngSubmit)="this.Botkit.send(inputTextInput.value,$event)">
                        <div class="inputPanel">
                            <!-- <i class="ion ion-ios-attach icocolor"></i> -->
                            <input #inputTextInput type="text" autocomplete="off" id="messenger_input"
                                placeholder="Ask for Data..." (keydown)="Botkit.onKeyDownHandler($event)"
                                (blur)="Botkit.resetSuggestion()" />
                            <!-- <i class="fa fa-smile icocolor2"></i> -->
                            <i (click)="chatSpeechRecognition()" [ngbTooltip]="'Search by voice'"
                                class="ion ion-ios-mic micro-phone icocolor"></i>
                        </div>
                        <button type="submit" [ngbTooltip]="'Send'"><i class="fa fa-paper-plane fa-2x"></i></button>
                    </form>
                </footer>
            </div>
        </div>
    </div>
</ng-container>

<ng-container *ngIf="showDetailView">
    <div class="backdrop">
        <div id="divChatDetail" class="jarvisPopup">
            <div class="header">
                <h4>Detail View</h4>
                <i class="ion ion-ios-close" style="font-size:22px;" (click)="closePopup()"></i>
            </div>

            <div class="scrollContainer">
                <ng-container *ngIf="dataLoaded">
                    <hx-entityDocs [selectedChart]="emptyObject" [resultData]="entityData" [callbackJson]="callbackJson"
                        [pivot_config]="emptyObject">
                    </hx-entityDocs>
                </ng-container>
            </div>

            <ng-container *ngIf="!dataLoaded">
                <div class="chatLoader"><img src="assets/img/Loader.svg" /></div>
            </ng-container>

        </div>
    </div>
</ng-container>

<ng-container *ngIf="showChartZoomView">
    <div class="backdrop">
        <div id="divChatDetail" class="jarvisPopup">
            <div class="header">
                <h4>Zoom View</h4>
                <i class="ion ion-ios-close" style="font-size:22px;" (click)="closePopup()"></i>
            </div>
            <div class="scrollContainer">
                <ng-container *ngFor="let item of showChartZoomView;let ind = index">
                    <div class="dynamicChart_{{ind}}"></div>
                </ng-container>
            </div>
        </div>
    </div>
</ng-container>


<ng-container *ngIf="showShareConv">
    <div class="backdrop">
        <div id="divShareUserList" class="shareuserInner">
            <div class="header">
                <h4>Share Conversation</h4>
                <i class="ion ion-ios-close" style="font-size:22px;" (click)="closePopup('showDetailView')"></i>
            </div>
            <ng-container *ngIf="dataLoaded">
                <ul class="userlist">
                    <ng-container *ngFor="let usr of userList">
                        <li *ngIf="usr.email != logged_in_user.email"
                            (click)="Botkit.setSelectedUserToShare(usr.email)">

                            <div class="chat_PicBox"><span title="{{usr}}"
                                    [className]="'chat_pic profilepic_Initia_'+ usr.firstInitial">{{usr.initials}}</span>
                            </div>
                            <label>{{usr.firstname}}
                                &nbsp;{{usr.lastname}}</label>
                            <input data-id="usr.email" type="checkbox"
                                [(ngModel)]="Botkit.selectedUserToShare[usr.email]" />
                        </li>

                    </ng-container>
                </ul>
                <div class="shareAction"><button (click)="Botkit.shareThisConversation(usr)">Share</button>
                </div>
            </ng-container>

            <ng-container *ngIf="!dataLoaded">
                <div class="chatLoader"><img src="assets/img/Loader.svg" />
                </div>
            </ng-container>
        </div>
    </div>
</ng-container>




<ng-container *ngIf="showAddPeople">
    <div class="backdrop">
        <div id="divAddPeople" class="shareuserInner">
            <div class="header">
                <h4>Add People</h4>
                <i class="ion ion-ios-close" style="font-size:22px;" (click)="closePopup()"></i>
            </div>
            <ng-container *ngIf="dataLoaded">
                <ul class="userlist">
                    <ng-container *ngFor="let usr of userList">
                        <li *ngIf="usr.email != logged_in_user.email"
                            (click)="Botkit.setSelectedUserToShare(usr.email)">

                            <div class="chat_PicBox"><span title="{{usr}}"
                                    [className]="'chat_pic profilepic_Initia_'+ usr.firstInitial">{{usr.initials}}</span>
                            </div>
                            <label>{{usr.firstname}}
                                &nbsp;{{usr.lastname}}</label>
                            <input data-id="usr.email" type="checkbox"
                                [disabled]="usr.email == conversationAdmin.user_id? true : false"
                                [(ngModel)]="Botkit.selectedUserToShare[usr.email]" />
                        </li>
                    </ng-container>
                </ul>
                <div class="shareAction"><button (click)="Botkit.addPeopleInConversation()">Add/Remove People</button>
                </div>
            </ng-container>

            <ng-container *ngIf="!dataLoaded">
                <div class="chatLoader"><img src="assets/img/Loader.svg" />
                </div>
            </ng-container>
        </div>
    </div>
</ng-container>

<ng-container *ngIf="showAddedPeople">
    <div class="backdrop">
        <div id="divAddedPeople" class="shareuserInner">
            <div class="header">
                <h4>Members Added</h4>
                <i class="ion ion-ios-close" style="font-size:22px;" (click)="closePopup()"></i>
            </div>
            <ul class="userlist">
                <ng-container *ngFor="let usr of activeConversation.userNames">
                    <li>
                        <div class="chat_PicBox"><span title="{{usr}}"
                                [className]="'chat_pic profilepic_Initia_'+activeConversation.firstInitial[usr]">{{activeConversation.memberInitials[usr]}}</span>
                        </div>
                        <label>{{usr}}</label>
                    </li>
                </ng-container>
                <li>
                    <div class="chat_PicBox"><span title="{{logged_in_user.fullName}}"
                            [className]="'chat_pic profilepic_Initia_'+logged_in_user.firstInitial">{{logged_in_user.initials}}</span>
                    </div>
                    <label>You</label>
                </li>

            </ul>
        </div>
    </div>
</ng-container>


<!-- DELETE Conversation POPUP -->
<ng-template #deleteConversation let-c="close" let-d="dismiss" class="modal fade-scale">
    <div class="modal-header">
        <h2 class="modal-title confirm-dialog"><i class="fa fa-exclamation-circle" aria-hidden="true"></i>
            <span class="font-weight-light">Confirmation</span>
        </h2>

        <button type="button" class="close" (click)="Botkit.closeModal()">&times;</button>
    </div>

    <div class="modal-body">
        <!-- <h3>Are you sure?</h3> -->
        <p class="unpin-text mb-0">Do you really want to delete this conversation! This process cannot be undone.</p>
    </div>

    <div class="modal-footer">

        <button type="button" class="btn btn-default" (click)="Botkit.closeModal()">Cancel</button>
        <button type="button" class="btn btn-primary btn-material" (click)="Botkit.deleteConversation()">Yes,
            delete it!</button>
    </div>
</ng-template>
<!--DELETE Conversation POPUP -->

<!-- DELETE Conversation Message POPUP -->
<ng-template #deleteMessage let-c="close" let-d="dismiss" class="modal fade-scale">
    <div class="modal-header">
        <h2 class="modal-title confirm-dialog"><i class="fa fa-exclamation-circle" aria-hidden="true"></i>
            <span class="font-weight-light">Confirmation</span>
        </h2>

        <button type="button" class="close" (click)="Botkit.closeModal()">&times;</button>
    </div>

    <div class="modal-body">
        <!-- <h3>Are you sure?</h3> -->
        <p class="unpin-text mb-0">Do you really want to delete this message! This process cannot be undone.</p>
    </div>

    <div class="modal-footer">

        <button type="button" class="btn btn-default" (click)="Botkit.closeModal()">Cancel</button>
        <button type="button" class="btn btn-primary btn-material" (click)="Botkit.deleteConversationMessage()">Yes,
            delete it!</button>
    </div>
</ng-template>
<!--DELETE Conversation Message POPUP -->



<div id="divRunTimeStuff"></div>